
PrintMagmaPresentation := function( S, file )
    local pcp, rel, i, j, e, d, k;
    pcp := Pcp(S);
    rel := RelativeOrdersOfPcp( pcp );
    PrintTo( file, "q := quo< GrpGPC:FreeGroup(",Length(pcp),"| \n");
    for i in [1..Length(pcp)] do
     
        # powers
        if rel[i] > 0 then
            e := ExponentsByPcp( pcp, pcp[i]^rel[i] );
            if e = 0 * e then
                AppendTo( file, "g",i,"^",rel[i]);
            else
                AppendTo( file, "g",i,"^",rel[i]," = ");
            fi;
            d := DepthVector(e);
            for k in [d..Length(pcp)] do
                if k > d and e[k] <> 0 then AppendTo( file," * " ); fi;
                if e[k] <> 0 then AppendTo( file, "g",k,"^",e[k] ); fi;
            od;
            AppendTo( file, ",\n");
        fi;
            
        for j in [i+1..Length(pcp)] do
            e := ExponentsByPcp( pcp, pcp[j]^pcp[i] );
            if e = 0 * e then
                AppendTo( file, "g",i,"^",rel[i]);
            else
                AppendTo( file, "g",j,"^g",i," = ");
            fi;
            d := DepthVector(e);
            for k in [d..Length(pcp)] do
                if k > d and e[k] <> 0 then AppendTo( file," * " ); fi;
                if e[k] <> 0 then AppendTo( file, "g",k,"^",e[k] ); fi;
            od;
            AppendTo( file, ",\n");
        od;
    od;
    AppendTo(file," Check:= false >;\n");
    AppendTo(file," Append(~L, q); \n");
end;
