
TWIGG0 := List([1..4], x -> []);
TWIGG1 := List([1..4], x -> []);
TWIGG2 := List([1..4], x -> []);

for l in listG0 do
    i := l[1]; j := l[2]; k := l[3]; 
    if not IsBound(TWIGG0[i][j]) then TWIGG0[i][j] := []; fi;
    file := Concatenation("twigsG/twig0_",String(i),"_",String(j),"_",
                            String(k),".gi");
    Read(file);
od;

for l in listG1 do
    i := l[1]; j := l[2]; k := l[3];
    if not IsBound(TWIGG1[i][j]) then TWIGG1[i][j] := []; fi;
    file := Concatenation("twigsG/twig1_",String(i),"_",String(j),"_",
                            String(k),".gi");
    Read(file);
od;

for l in listG2 do
    i := l[1]; j := l[2]; k := l[3];
    if not IsBound(TWIGG2[i][j]) then TWIGG2[i][j] := []; fi;
    file := Concatenation("twigsG/twig2_",String(i),"_",String(j),"_",
                            String(k),".gi");
    Read(file);
od;

DisplayBranchInfoG0 := function(j)
    local k, i, T, a, b, l;
    for k in [1..BranchLimitG0(j)] do
        for i in [1..4] do
            if IsBound(TWIGG0[i][j]) and IsBound(TWIGG0[i][j][k]) then
                T := TWIGG0[i][j][k];
                a := DepthOfTwig(T);
                b := SizeOfTwig(T);
                l := 5-Length(DigitsNumber(b,10));
                Print(a,"-",b);
                if l = 1 then Print(" "); fi;
                if l = 2 then Print("  "); fi;
                if l = 3 then Print("   "); fi;
                if l = 4 then Print("    "); fi;
            else
                Print("-------");
            fi;
            if i<4 then 
                Print("  "); 
            else
                Print("\n");
            fi;
        od;
    od;
    Print("\n");
end;

DisplayBranchInfoG1 := function(j)
    local k, i, T, a, b, l;
    for k in [1..BranchLimitG1(j)] do
        for i in [1..4] do
            if IsBound(TWIGG1[i][j]) and IsBound(TWIGG1[i][j][k]) then
                T := TWIGG1[i][j][k];
                a := DepthOfTwig(T);
                b := SizeOfTwig(T);
                l := 5-Length(DigitsNumber(b,10));
                Print(a,"-",b);
                if l = 1 then Print(" "); fi;
                if l = 2 then Print("  "); fi;
                if l = 3 then Print("   "); fi;
                if l = 4 then Print("    "); fi;
            else
                Print("-------");
            fi;
            if i<4 then 
                Print("  ");
            else
                Print("\n");
            fi;
        od;
    od;
    Print("\n");
end;

DisplayBranchInfoG2 := function(j)
    local k, i, T, a, b, l;
    for k in [1..BranchLimitG2(j)] do
        for i in [1..4] do
            if IsBound(TWIGG2[i][j]) and IsBound(TWIGG2[i][j][k]) then
                T := TWIGG2[i][j][k];
                a := DepthOfTwig(T);
                b := SizeOfTwig(T);
                l := 5-Length(DigitsNumber(b,10));
                Print(a,"-",b);
                if l = 1 then Print(" "); fi;
                if l = 2 then Print("  "); fi;
                if l = 3 then Print("   "); fi;
                if l = 4 then Print("    "); fi;
            else
                Print("-------");
            fi;
            if i<4 then 
                Print("  ");
            else
                Print("\n");
            fi;
        od;
    od;
    Print("\n");
end;

ALLSG := [[15,18,21,24],
          [18,21,24,27],
          [21,24,27,30]];
SkelNum := function(m,j)
    if m = 1 and IsInt(j/6) then return 3; fi;
    if m = 1 and not IsInt(j/6) then return 4; fi;

    if m = 2 and IsInt(j/6) then return 3; fi;
    if m = 2 and not IsInt(j/6) then return 4; fi;

    if m = 3 and IsInt(j/6) then return 4; fi;
    if m = 3 and not IsInt(j/6) then return 3; fi;
end;

CheckTwigsG := function(m)
    local BrL, TW, r, i, j, k, T, h, s, p;

    if m = 1 then BrL := BranchLimitG1; TW := TWIGG1; fi;
    if m = 2 then BrL := BranchLimitG2; TW := TWIGG2; fi;
    if m = 3 then BrL := BranchLimitG0; TW := TWIGG0; fi;
    
    r := [];
    s := [];
    p := [];

    for j in ALLSG[m] do
        for i in [1..SkelNum(m,j)] do
            for k in [1..BrL(j)] do
                if IsBound(TW[i][j][k]) then
                    T := TW[i][j][k];
                    h := Position(r, T);
                    if IsBool(h) then
                        Add(r,T);
                        h := Position(s, [DepthOfTwig(T), SizeOfTwig(T)]);
                        if IsBool(h) then
                            Add(p, [i,j,k]);
                        else
                            Add(p, [i,j,k,h]);
                        fi;
                        Add(s, [DepthOfTwig(T),SizeOfTwig(T)]);
                    fi;
                fi;
            od;
        od;
    od;
    return rec(r := r, s := s, p := p);
end;

