
RandomSupplement := function( nat, vecs )
    local H, D, G, i;
    
    H := Image(nat);
    D := Kernel(nat);
    G := Source(nat);

    for i in [1..Length(vecs)] do
        vecs[i] := MappedVector(vecs[i], Igs(H));
        vecs[i] := PreImagesRepresentative(nat, vecs[i]);
        vecs[i] := vecs[i] * Random(D);
    od;

    return Subgroup(G, vecs);
end;
 
