#############################################################################
##
#W matrix.gi               Package Coclass                      Bettina Eick
##

AntiSymmetricPower := function(mat)
    local dim, new, row, x, j, k, m, n;
    dim := Length(mat);
    new := [ ];
    for j  in [1 .. dim]  do
        for k  in [1 .. j - 1]  do
            row := [ ];
            for m  in [1 .. dim]  do
                for n  in [1 .. m - 1]  do
                    x := mat[j][m] * mat[k][n] - mat[j][n] * mat[k][m];
                    Add(row, x);
                od;
            od;
            Add(new, row);
        od;
    od;
    return new;
end;

